Package com.smartgwt.client.tools

# Class PaletteNode

java.lang.Object
com.smartgwt.client.core.JsObject
com.smartgwt.client.core.DataClass
com.smartgwt.client.core.RefDataClass
com.smartgwt.client.data.Record
com.smartgwt.client.widgets.grid.ListGridRecord
com.smartgwt.client.widgets.tree.TreeNode
com.smartgwt.client.tools.PaletteNode

All Implemented Interfaces:
  `HasHandlers`

Direct Known Subclasses:
  `EditNode`

public class PaletteNode extends TreeNode
An object representing a component which the user may create dynamically within an application.

A PaletteNode expresses visual properties for how the palette will display it (eg `title`, `icon`) as well as instructions for creating the component the paletteNode represents (`type`, `defaults`).

Various types of palettes (`ListPalette`, `TreePalette`, `MenuPalette`, `TilePalette`) render a PaletteNode in different ways, and allow the user to trigger creation in different ways (eg drag and drop, or just click). All share a common pattern for how components are created from palettes.

Note that in a TreePalette, a PaletteNode is essentially a `TreeNode` and can have properties expected for a TreeNode (eg, `showDropIcon`). Likewise a PaletteNode in a MenuPalette can have the properties of a `MenuItem`, such as `MenuItem.enableIf()`.

- ## Field Summary

  ### Fields inherited from class com.smartgwt.client.core.RefDataClass

  `id`

  ### Fields inherited from class com.smartgwt.client.core.DataClass

  `factoryCreated, factoryProperties`

  ### Fields inherited from class com.smartgwt.client.core.JsObject

  `jsObj`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `PaletteNode()`
  `PaletteNode(JavaScriptObject jsObj)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Boolean`
  `getAlwaysUsePlaceholder()`
  If set to true, indicates that a Placeholder should always be shown in place of the actual component.
  `Boolean`
  `getCanDuplicate()`
  If set to false, indicates that this node cannot be `copy & pasted`, including disallowing calls to `EditContext.makePaletteNode()` for `EditNodes` created from this `PaletteNode`.
  `Canvas`
  `getCanvasDefaults()`
  Defaults for the component to be created from this palette.
  `Canvas`
  `getCanvasLiveObject()`
  For a paletteNode which should be a "singleton", that is, always provides the exact same object (==) rather than a dynamically created copy, provide the singleton object as `liveObject`.
  `DrawItem`
  `getDrawItemDefaults()`
  Defaults for the component to be created from this palette.
  `DrawItem`
  `getDrawItemLiveObject()`
  For a paletteNode which should be a "singleton", that is, always provides the exact same object (==) rather than a dynamically created copy, provide the singleton object as `liveObject`.
  `DrawPane`
  `getDrawPaneDefaults()`
  Defaults for the component to be created from this palette.
  `DrawPane`
  `getDrawPaneLiveObject()`
  For a paletteNode which should be a "singleton", that is, always provides the exact same object (==) rather than a dynamically created copy, provide the singleton object as `liveObject`.
  `EditNode`
  `getEditNodeProperties()`
  Properties to be applied to the `editNode` when created.
  `EditProxy`
  `getEditProxyProperties()`
  Properties to be applied to the `liveObject`.`editProxy` when created.
  `FormItem`
  `getFormItemDefaults()`
  Defaults for the component to be created from this palette.
  `FormItem`
  `getFormItemLiveObject()`
  For a paletteNode which should be a "singleton", that is, always provides the exact same object (==) rather than a dynamically created copy, provide the singleton object as `liveObject`.
  `String`
  `getIcon()`
  Icon for this paletteNode.
  `String`
  `getIdName()`
  Name used to create unique component ID.
  `String`
  `getIdPrefix()`
  Deprecated.
  As of Smart GWT version 12.1, deprecated in favor of `idName`
  `Object`
  `getLiveObject()`
  For a paletteNode which should be a "singleton", that is, always provides the exact same object (==) rather than a dynamically created copy, provide the singleton object as `liveObject`.
  `static PaletteNode`
  `getOrCreateRef(JavaScriptObject jsObj)`
  `String`
  `getPlaceholderImage()`
  Image to display in lieu of the usual placeholder text.
  `Label`
  `getPlaceholderProperties()`
  Properties to be applied to the `liveObject` when created as a Placeholder.
  `Boolean`
  `getRecreateOnChange()`
  If set to true, indicates instead of updating the changed property on the target live component a new live component is created with the current configured properties.
  `String`
  `getRequiredProperties()`
  Comma separated list of properties for this component that must be provided in `EditNode.defaults` before the component will be created.
  `String`
  `getTitle()`
  Textual title for this paletteNode.
  `String`
  `getType()`
  String this paletteNode creates, for example, "ListGrid".
  `PaletteNode`
  `setAlwaysUsePlaceholder(Boolean alwaysUsePlaceholder)`
  If set to true, indicates that a Placeholder should always be shown in place of the actual component.
  `PaletteNode`
  `setCanDuplicate(Boolean canDuplicate)`
  If set to false, indicates that this node cannot be `copy & pasted`, including disallowing calls to `EditContext.makePaletteNode()` for `EditNodes` created from this `PaletteNode`.
  `PaletteNode`
  `setCanvasDefaults(Canvas defaults)`
  Defaults for the component to be created from this palette.
  `PaletteNode`
  `setCanvasLiveObject(Canvas liveObject)`
  For a paletteNode which should be a "singleton", that is, always provides the exact same object (==) rather than a dynamically created copy, provide the singleton object as `liveObject`.
  `PaletteNode`
  `setDrawItemDefaults(DrawItem defaults)`
  Defaults for the component to be created from this palette.
  `PaletteNode`
  `setDrawItemLiveObject(DrawItem liveObject)`
  For a paletteNode which should be a "singleton", that is, always provides the exact same object (==) rather than a dynamically created copy, provide the singleton object as `liveObject`.
  `PaletteNode`
  `setDrawPaneDefaults(DrawPane defaults)`
  Defaults for the component to be created from this palette.
  `PaletteNode`
  `setDrawPaneLiveObject(DrawPane liveObject)`
  For a paletteNode which should be a "singleton", that is, always provides the exact same object (==) rather than a dynamically created copy, provide the singleton object as `liveObject`.
  `PaletteNode`
  `setEditNodeProperties(EditNode editNodeProperties)`
  Properties to be applied to the `editNode` when created.
  `PaletteNode`
  `setEditProxyProperties(EditProxy editProxyProperties)`
  Properties to be applied to the `liveObject`.`editProxy` when created.
  `PaletteNode`
  `setFormItemDefaults(FormItem defaults)`
  Defaults for the component to be created from this palette.
  `PaletteNode`
  `setFormItemLiveObject(FormItem liveObject)`
  For a paletteNode which should be a "singleton", that is, always provides the exact same object (==) rather than a dynamically created copy, provide the singleton object as `liveObject`.
  `PaletteNode`
  `setIcon(String icon)`
  Icon for this paletteNode.
  `PaletteNode`
  `setIdName(String idName)`
  Name used to create unique component ID.
  `PaletteNode`
  `setIdPrefix(String idPrefix)`
  Deprecated.
  As of Smart GWT version 12.1, deprecated in favor of `idName`
  `PaletteNode`
  `setPlaceholderImage(String placeholderImage)`
  Image to display in lieu of the usual placeholder text.
  `PaletteNode`
  `setPlaceholderProperties(Label placeholderProperties)`
  Properties to be applied to the `liveObject` when created as a Placeholder.
  `PaletteNode`
  `setRecreateOnChange(Boolean recreateOnChange)`
  If set to true, indicates instead of updating the changed property on the target live component a new live component is created with the current configured properties.
  `PaletteNode`
  `setRequiredProperties(String requiredProperties)`
  Comma separated list of properties for this component that must be provided in `EditNode.defaults` before the component will be created.
  `PaletteNode`
  `setTitle(String title)`
  Textual title for this paletteNode.
  `PaletteNode`
  `setType(String type)`
  String this paletteNode creates, for example, "ListGrid".

  ### Methods inherited from class com.smartgwt.client.widgets.tree.TreeNode

  `getCanAcceptDrop, getCanDrag, getEnabled, getIconPadding, getName, getShowDropIcon, getShowOpenIcon, getShowSelectedIcon, setCanAcceptDrop, setCanDrag, setChildren, setEnabled, setIconPadding, setID, setIsFolder, setName, setParentID, setShowDropIcon, setShowOpenIcon, setShowSelectedIcon`

  ### Methods inherited from class com.smartgwt.client.widgets.grid.ListGridRecord

  `get_baseStyle, get_canEdit, get_canRemove, getBackgroundComponent, getCanExpand, getCanSelect, getCustomStyle, getDetailDS, getEmbeddedComponent, getEmbeddedComponentFields, getEmbeddedComponentPosition, getIncludeInSummary, getIsGridSummary, getIsGroupSummary, getIsSeparator, getLinkText, getShowRollOver, getSingleCellValue, set_baseStyle, set_canEdit, set_canRemove, setBackgroundComponent, setCanExpand, setCanSelect, setCustomStyle, setDetailDS, setEmbeddedComponent, setEmbeddedComponentFields, setEmbeddedComponentPosition, setIncludeInSummary, setIsGridSummary, setIsGroupSummary, setIsSeparator, setLinkText, setShowRollOver, setSingleCellValue`

  ### Methods inherited from class com.smartgwt.client.data.Record

  `convertToRecordArray, copyAttributes, copyAttributesInto, getAttributeAsRecordArray, getAttributeAsRecordList, getPaletteDefaults, isARecord, toMap`

  ### Methods inherited from class com.smartgwt.client.core.RefDataClass

  `getRef, getRef, internalSetID`

  ### Methods inherited from class com.smartgwt.client.core.DataClass

  `applyFactoryProperties, doAddHandler, fireEvent, getAttribute, getAttributeAsBoolean, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDouble, getAttributeAsDoubleArray, getAttributeAsElement, getAttributeAsFloat, getAttributeAsInt, getAttributeAsIntArray, getAttributeAsJavaScriptObject, getAttributeAsLong, getAttributeAsMap, getAttributeAsObject, getAttributeAsRecord, getAttributeAsString, getAttributeAsStringArray, getAttributes, getHandlerCount, isFactoryCreated, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttributeAsJavaObject, setFactoryCreated`

  ### Methods inherited from class com.smartgwt.client.core.JsObject

  `equals, getJsObj, hashCode, isCreated, setJavaScriptObject, setJsObj`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### PaletteNode

    public PaletteNode()

  - ### PaletteNode

    public PaletteNode(JavaScriptObject jsObj)

- ## Method Details

  - ### getOrCreateRef

    public static PaletteNode getOrCreateRef(JavaScriptObject jsObj)

  - ### setAlwaysUsePlaceholder

    public PaletteNode setAlwaysUsePlaceholder(Boolean alwaysUsePlaceholder)
    If set to true, indicates that a Placeholder should always be shown in place of the actual component.
    Parameters:
      `alwaysUsePlaceholder` - New alwaysUsePlaceholder value. Default value is null
    Returns:
      `PaletteNode` instance, for chaining setter calls

  - ### getAlwaysUsePlaceholder

    public Boolean getAlwaysUsePlaceholder()
    If set to true, indicates that a Placeholder should always be shown in place of the actual component.
    Returns:
      Current alwaysUsePlaceholder value. Default value is null

  - ### setCanDuplicate

    public PaletteNode setCanDuplicate(Boolean canDuplicate)
    If set to false, indicates that this node cannot be `copy & pasted`, including disallowing calls to `EditContext.makePaletteNode()` for `EditNodes` created from this `PaletteNode`.
    Parameters:
      `canDuplicate` - New canDuplicate value. Default value is null
    Returns:
      `PaletteNode` instance, for chaining setter calls

  - ### getCanDuplicate

    public Boolean getCanDuplicate()
    If set to false, indicates that this node cannot be `copy & pasted`, including disallowing calls to `EditContext.makePaletteNode()` for `EditNodes` created from this `PaletteNode`.
    Returns:
      Current canDuplicate value. Default value is null

  - ### setCanvasDefaults

    public PaletteNode setCanvasDefaults(Canvas defaults)
    Defaults for the component to be created from this palette.

    For example, if `type` is "ListGrid", properties valid to pass to ListGrid.create().

    Note that event handlers or method overrides cannot be configured as `defaults`, as they cannot be serialized or restored. Instead, create a subclass that implements the desired behaviors, and use that subclass as `type`.

    See also `Reflection` for special concerns when making a GWT subclass usable in `Component XML` and `Dashboards & Tools` in general.

    Parameters:
      `defaults` - New defaults value. Default value is null
    Returns:
      `PaletteNode` instance, for chaining setter calls
    See Also:
      - `SGWTProperties`

  - ### getCanvasDefaults

    public Canvas getCanvasDefaults()
    Defaults for the component to be created from this palette.

    For example, if `type` is "ListGrid", properties valid to pass to ListGrid.create().

    Note that event handlers or method overrides cannot be configured as `defaults`, as they cannot be serialized or restored. Instead, create a subclass that implements the desired behaviors, and use that subclass as `type`.

    See also `Reflection` for special concerns when making a GWT subclass usable in `Component XML` and `Dashboards & Tools` in general.

    Returns:
      Current defaults value. Default value is null

  - ### setCanvasLiveObject

    public PaletteNode setCanvasLiveObject(Canvas liveObject)
    For a paletteNode which should be a "singleton", that is, always provides the exact same object (==) rather than a dynamically created copy, provide the singleton object as `liveObject`.

    Instead of dynamically creating an object from defaults, the `liveObject` will simply be assigned to `EditNode.liveObject` for the created editNode.

    Parameters:
      `liveObject` - New liveObject value. Default value is null
    Returns:
      `PaletteNode` instance, for chaining setter calls

  - ### getCanvasLiveObject

    public Canvas getCanvasLiveObject()
    For a paletteNode which should be a "singleton", that is, always provides the exact same object (==) rather than a dynamically created copy, provide the singleton object as `liveObject`.

    Instead of dynamically creating an object from defaults, the `liveObject` will simply be assigned to `EditNode.liveObject` for the created editNode.

    Returns:
      Current liveObject value. Default value is null

  - ### setDrawItemDefaults

    public PaletteNode setDrawItemDefaults(DrawItem defaults)
    Defaults for the component to be created from this palette.

    For example, if `type` is "ListGrid", properties valid to pass to ListGrid.create().

    Note that event handlers or method overrides cannot be configured as `defaults`, as they cannot be serialized or restored. Instead, create a subclass that implements the desired behaviors, and use that subclass as `type`.

    See also `Reflection` for special concerns when making a GWT subclass usable in `Component XML` and `Dashboards & Tools` in general.

    Parameters:
      `defaults` - New defaults value. Default value is null
    Returns:
      `PaletteNode` instance, for chaining setter calls
    See Also:
      - `SGWTProperties`

  - ### getDrawItemDefaults

    public DrawItem getDrawItemDefaults()
    Defaults for the component to be created from this palette.

    For example, if `type` is "ListGrid", properties valid to pass to ListGrid.create().

    Note that event handlers or method overrides cannot be configured as `defaults`, as they cannot be serialized or restored. Instead, create a subclass that implements the desired behaviors, and use that subclass as `type`.

    See also `Reflection` for special concerns when making a GWT subclass usable in `Component XML` and `Dashboards & Tools` in general.

    Returns:
      Current defaults value. Default value is null

  - ### setDrawItemLiveObject

    public PaletteNode setDrawItemLiveObject(DrawItem liveObject)
    For a paletteNode which should be a "singleton", that is, always provides the exact same object (==) rather than a dynamically created copy, provide the singleton object as `liveObject`.

    Instead of dynamically creating an object from defaults, the `liveObject` will simply be assigned to `EditNode.liveObject` for the created editNode.

    Parameters:
      `liveObject` - New liveObject value. Default value is null
    Returns:
      `PaletteNode` instance, for chaining setter calls

  - ### getDrawItemLiveObject

    public DrawItem getDrawItemLiveObject()
    For a paletteNode which should be a "singleton", that is, always provides the exact same object (==) rather than a dynamically created copy, provide the singleton object as `liveObject`.

    Instead of dynamically creating an object from defaults, the `liveObject` will simply be assigned to `EditNode.liveObject` for the created editNode.

    Returns:
      Current liveObject value. Default value is null

  - ### setDrawPaneDefaults

    public PaletteNode setDrawPaneDefaults(DrawPane defaults)
    Defaults for the component to be created from this palette.

    For example, if `type` is "ListGrid", properties valid to pass to ListGrid.create().

    Note that event handlers or method overrides cannot be configured as `defaults`, as they cannot be serialized or restored. Instead, create a subclass that implements the desired behaviors, and use that subclass as `type`.

    See also `Reflection` for special concerns when making a GWT subclass usable in `Component XML` and `Dashboards & Tools` in general.

    Parameters:
      `defaults` - New defaults value. Default value is null
    Returns:
      `PaletteNode` instance, for chaining setter calls
    See Also:
      - `SGWTProperties`

  - ### getDrawPaneDefaults

    public DrawPane getDrawPaneDefaults()
    Defaults for the component to be created from this palette.

    For example, if `type` is "ListGrid", properties valid to pass to ListGrid.create().

    Note that event handlers or method overrides cannot be configured as `defaults`, as they cannot be serialized or restored. Instead, create a subclass that implements the desired behaviors, and use that subclass as `type`.

    See also `Reflection` for special concerns when making a GWT subclass usable in `Component XML` and `Dashboards & Tools` in general.

    Returns:
      Current defaults value. Default value is null

  - ### setDrawPaneLiveObject

    public PaletteNode setDrawPaneLiveObject(DrawPane liveObject)
    For a paletteNode which should be a "singleton", that is, always provides the exact same object (==) rather than a dynamically created copy, provide the singleton object as `liveObject`.

    Instead of dynamically creating an object from defaults, the `liveObject` will simply be assigned to `EditNode.liveObject` for the created editNode.

    Parameters:
      `liveObject` - New liveObject value. Default value is null
    Returns:
      `PaletteNode` instance, for chaining setter calls

  - ### getDrawPaneLiveObject

    public DrawPane getDrawPaneLiveObject()
    For a paletteNode which should be a "singleton", that is, always provides the exact same object (==) rather than a dynamically created copy, provide the singleton object as `liveObject`.

    Instead of dynamically creating an object from defaults, the `liveObject` will simply be assigned to `EditNode.liveObject` for the created editNode.

    Returns:
      Current liveObject value. Default value is null

  - ### setEditNodeProperties

    public PaletteNode setEditNodeProperties(EditNode editNodeProperties)
    Properties to be applied to the `editNode` when created.
    Parameters:
      `editNodeProperties` - New editNodeProperties value. Default value is null
    Returns:
      `PaletteNode` instance, for chaining setter calls

  - ### getEditNodeProperties

    public EditNode getEditNodeProperties()
    Properties to be applied to the `editNode` when created.
    Returns:
      Current editNodeProperties value. Default value is null

  - ### setEditProxyProperties

    public PaletteNode setEditProxyProperties(EditProxy editProxyProperties)
    Properties to be applied to the `liveObject`.`editProxy` when created.
    Parameters:
      `editProxyProperties` - New editProxyProperties value. Default value is null
    Returns:
      `PaletteNode` instance, for chaining setter calls
    See Also:
      - `SGWTProperties`

  - ### getEditProxyProperties

    public EditProxy getEditProxyProperties()
    Properties to be applied to the `liveObject`.`editProxy` when created.
    Returns:
      Current editProxyProperties value. Default value is null

  - ### setFormItemDefaults

    public PaletteNode setFormItemDefaults(FormItem defaults)
    Defaults for the component to be created from this palette.

    For example, if `type` is "ListGrid", properties valid to pass to ListGrid.create().

    Note that event handlers or method overrides cannot be configured as `defaults`, as they cannot be serialized or restored. Instead, create a subclass that implements the desired behaviors, and use that subclass as `type`.

    See also `Reflection` for special concerns when making a GWT subclass usable in `Component XML` and `Dashboards & Tools` in general.

    Parameters:
      `defaults` - New defaults value. Default value is null
    Returns:
      `PaletteNode` instance, for chaining setter calls

  - ### getFormItemDefaults

    public FormItem getFormItemDefaults()
    Defaults for the component to be created from this palette.

    For example, if `type` is "ListGrid", properties valid to pass to ListGrid.create().

    Note that event handlers or method overrides cannot be configured as `defaults`, as they cannot be serialized or restored. Instead, create a subclass that implements the desired behaviors, and use that subclass as `type`.

    See also `Reflection` for special concerns when making a GWT subclass usable in `Component XML` and `Dashboards & Tools` in general.

    Returns:
      Current defaults value. Default value is null

  - ### setFormItemLiveObject

    public PaletteNode setFormItemLiveObject(FormItem liveObject)
    For a paletteNode which should be a "singleton", that is, always provides the exact same object (==) rather than a dynamically created copy, provide the singleton object as `liveObject`.

    Instead of dynamically creating an object from defaults, the `liveObject` will simply be assigned to `EditNode.liveObject` for the created editNode.

    Parameters:
      `liveObject` - New liveObject value. Default value is null
    Returns:
      `PaletteNode` instance, for chaining setter calls

  - ### getFormItemLiveObject

    public FormItem getFormItemLiveObject()
    For a paletteNode which should be a "singleton", that is, always provides the exact same object (==) rather than a dynamically created copy, provide the singleton object as `liveObject`.

    Instead of dynamically creating an object from defaults, the `liveObject` will simply be assigned to `EditNode.liveObject` for the created editNode.

    Returns:
      Current liveObject value. Default value is null

  - ### setIcon

    public PaletteNode setIcon(String icon)
    Icon for this paletteNode.
    Overrides:
      `setIcon` in class `TreeNode`
    Parameters:
      `icon` - New icon value. Default value is null
    Returns:
      `PaletteNode` instance, for chaining setter calls
    See Also:
      - `SCImgURL`

  - ### getIcon

    public String getIcon()
    Icon for this paletteNode.
    Overrides:
      `getIcon` in class `TreeNode`
    Returns:
      Current icon value. Default value is null
    See Also:
      - `SCImgURL`

  - ### setIdName

    public PaletteNode setIdName(String idName)
    Name used to create unique component ID. If not specified, `type` is used.

    Note: idName must follow all rules for a `Identifier`.

    Parameters:
      `idName` - New idName value. Default value is null
    Returns:
      `PaletteNode` instance, for chaining setter calls

  - ### getIdName

    public String getIdName()
    Name used to create unique component ID. If not specified, `type` is used.

    Note: idName must follow all rules for a `Identifier`.

    Returns:
      Current idName value. Default value is null

  - ### setIdPrefix

    public PaletteNode setIdPrefix(String idPrefix)
    Deprecated.
    As of Smart GWT version 12.1, deprecated in favor of `idName`
    Prefix used to create unique component ID. If not specified, `type` is used.
    Parameters:
      `idPrefix` - New idPrefix value. Default value is null
    Returns:
      `PaletteNode` instance, for chaining setter calls

  - ### getIdPrefix

    public String getIdPrefix()
    Deprecated.
    As of Smart GWT version 12.1, deprecated in favor of `idName`
    Prefix used to create unique component ID. If not specified, `type` is used.
    Returns:
      Current idPrefix value. Default value is null

  - ### setPlaceholderImage

    public PaletteNode setPlaceholderImage(String placeholderImage)
    Image to display in lieu of the usual placeholder text.
    Parameters:
      `placeholderImage` - New placeholderImage value. Default value is null
    Returns:
      `PaletteNode` instance, for chaining setter calls
    See Also:
      - `SCImgURL`

  - ### getPlaceholderImage

    public String getPlaceholderImage()
    Image to display in lieu of the usual placeholder text.
    Returns:
      Current placeholderImage value. Default value is null
    See Also:
      - `SCImgURL`

  - ### setPlaceholderProperties

    public PaletteNode setPlaceholderProperties(Label placeholderProperties)
    Properties to be applied to the `liveObject` when created as a Placeholder.
    Parameters:
      `placeholderProperties` - New placeholderProperties value. Default value is null
    Returns:
      `PaletteNode` instance, for chaining setter calls
    See Also:
      - `SGWTProperties`

  - ### getPlaceholderProperties

    public Label getPlaceholderProperties()
    Properties to be applied to the `liveObject` when created as a Placeholder.
    Returns:
      Current placeholderProperties value. Default value is null

  - ### setRecreateOnChange

    public PaletteNode setRecreateOnChange(Boolean recreateOnChange)
    If set to true, indicates instead of updating the changed property on the target live component a new live component is created with the current configured properties.

    This property is typically set when a custom component is being used that doesn't support setters for any or most of its properties and a change can be reflected by recreating the component.

    Individual properties of the target component can be marked similarly on the component's schema for more fine-grained control. See `DataSourceField.recreateOnChange`.

    Parameters:
      `recreateOnChange` - New recreateOnChange value. Default value is null
    Returns:
      `PaletteNode` instance, for chaining setter calls

  - ### getRecreateOnChange

    public Boolean getRecreateOnChange()
    If set to true, indicates instead of updating the changed property on the target live component a new live component is created with the current configured properties.

    This property is typically set when a custom component is being used that doesn't support setters for any or most of its properties and a change can be reflected by recreating the component.

    Individual properties of the target component can be marked similarly on the component's schema for more fine-grained control. See `DataSourceField.recreateOnChange`.

    Returns:
      Current recreateOnChange value. Default value is null

  - ### setRequiredProperties

    public PaletteNode setRequiredProperties(String requiredProperties)
    Comma separated list of properties for this component that must be provided in `EditNode.defaults` before the component will be created. Otherwise a Placeholder will be used until the required properties are satisfied.
    Parameters:
      `requiredProperties` - New requiredProperties value. Default value is null
    Returns:
      `PaletteNode` instance, for chaining setter calls

  - ### getRequiredProperties

    public String getRequiredProperties()
    Comma separated list of properties for this component that must be provided in `EditNode.defaults` before the component will be created. Otherwise a Placeholder will be used until the required properties are satisfied.
    Returns:
      Current requiredProperties value. Default value is null

  - ### setTitle

    public PaletteNode setTitle(String title)
    Textual title for this paletteNode.
    Overrides:
      `setTitle` in class `TreeNode`
    Parameters:
      `title` - New title value. Default value is null
    Returns:
      `PaletteNode` instance, for chaining setter calls
    See Also:
      - `Tree.setTitleProperty(java.lang.String)`
      - `Tree.getTitle(com.smartgwt.client.widgets.tree.TreeNode)`
      - `HTMLString`

  - ### getTitle

    public String getTitle()
    Textual title for this paletteNode.
    Overrides:
      `getTitle` in class `TreeNode`
    Returns:
      Current title value. Default value is null
    See Also:
      - `Tree.getTitleProperty()`
      - `Tree.getTitle(com.smartgwt.client.widgets.tree.TreeNode)`
      - `HTMLString`

  - ### setType

    public PaletteNode setType(String type)
    String this paletteNode creates, for example, "ListGrid".
    Parameters:
      `type` - New type value. Default value is null
    Returns:
      `PaletteNode` instance, for chaining setter calls
    See Also:
      - `SCClassName`

  - ### getType

    public String getType()
    String this paletteNode creates, for example, "ListGrid".
    Returns:
      Current type value. Default value is null
    See Also:
      - `SCClassName`

  - ### getLiveObject

    public Object getLiveObject()
    For a paletteNode which should be a "singleton", that is, always provides the exact same object (==) rather than a dynamically created copy, provide the singleton object as `liveObject`.

    Instead of dynamically creating an object from defaults, the `liveObject` will simply be assigned to `EditNode.liveObject` for the created editNode.

    Use the more specific live object getter API, such as `getCanvasLiveObject()` if you are sure of the type.

    Returns:
      Object
    See Also:
      - `getCanvasLiveObject()`
      - `getDrawItemLiveObject()`
      - `getDrawPaneLiveObject()`
      - `getFormItemLiveObject()`